=== debian/changelog ===
boost-ext-ut (2.3.1-2) unstable; urgency=medium

  * Mark as Multi-Arch: foreign.

 -- Raul Tambre <raul@tambre.ee>  Sat, 05 Apr 2025 12:02:39 +0300

boost-ext-ut (2.3.1-1) unstable; urgency=medium

  * Update upstream.
  * Drop debian/patches/arch-indep.patch (merged upstream).
  * Switch debian/watch to Git mode.

 -- Raul Tambre <raul@tambre.ee>  Fri, 04 Apr 2025 14:04:36 +0300

boost-ext-ut (2.3.0-2) unstable; urgency=medium

  * Source-only upload.

 -- Raul Tambre <raul@tambre.ee>  Fri, 04 Apr 2025 10:48:53 +0300

boost-ext-ut (2.3.0-1) unstable; urgency=medium

  * Initial release (Closes: #1092173).

 -- Raul Tambre <raul@tambre.ee>  Fri, 28 Mar 2025 13:32:28 +0200
