=== debian/control ===
Source: boost-ext-ut
Section: libdevel
Priority: optional
Maintainer: Raul Tambre <raul@tambre.ee>
Homepage: https://boost-ext.github.io/ut/
Vcs-Browser: https://salsa.debian.org/tambre/boost-ext-ut
Vcs-Git: https://salsa.debian.org/tambre/boost-ext-ut.git
Standards-Version: 4.7.2
Rules-Requires-Root: no
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 dh-sequence-single-binary,
 valgrind-if-available <!nocheck>,

Package: libboost-ext-ut-dev
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: C++ single header/module, macro-free unit testing framework
 Boost μt is an easy-to-integrate single header/module C++20 TDD/BDD unit
 testing framework.
