=== debian/rules ===
#!/usr/bin/make -rf

ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
CONFIGURE_FLAGS += \
	-DBOOST_UT_BUILD_EXAMPLES=OFF \
	-DBOOST_UT_BUILD_TESTS=OFF
else
CONFIGURE_FLAGS += \
	-DBOOST_UT_BUILD_BENCHMARKS=ON \
	-DBOOST_UT_ENABLE_MEMCHECK=ON
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)
