=== debian/watch ===
version=4
opts=mode=git https://github.com/boost-ext/ut.git refs/tags/v@ANY_VERSION@
